/*
JT Power Bank
 
 */
#include <math.h>
#include <SPI.h>
#include <Wire.h>
#include <AsyncDelay.h>
#include <avr/pgmspace.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <Button.h>

#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);

#define NUMFLAKES 10
#define XPOS 0
#define YPOS 1
#define DELTAY 2
#define LOGO16_GLCD_HEIGHT 32
#define LOGO16_GLCD_WIDTH  128 

int sensorPin = A0;
int bat = 1; 
int curr_value = 0;
int acc_value = 0;
int vbat_dig = 0;
float vbat;
float supply = 5;


volatile unsigned long last_millis = 0;
Button button = Button(8,PULLUP);


void setup()  { 
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // initialize with the I2C addr 0x3C (for the 128x32)
  display.display();
  delay(2000);
  display.clearDisplay(); 
  pinMode(9,OUTPUT); // led at 9

} 


void loop()  {  
  if(button.isPressed()){
  if (bat == 6)   {
    bat = 1; 
   }   
  else {
    bat = ++bat;   
   } 
     digitalWrite(9, HIGH);
       delay(100);
       delay(100);
     digitalWrite(9, LOW);
       delay(100);
       delay(100);   
     digitalWrite(9, HIGH);
       delay(100);
       delay(100);
     digitalWrite(9, LOW);  
  }  
     switch (bat) {            
             case 1: 
             sensorPin = A0;  // Bar1
               break;             
             case 2:
             sensorPin = A1;  // Bat2 
               break;  
             case 3:
             sensorPin = A2;  // Bat2
               break;  
             case 4:
             sensorPin = A3;  // Bat2
               break;             
             case 5:
             sensorPin = A6;  // Bat2
               break;  
             case 6:
             sensorPin = A7;  // Bat2
               break;                          
          } 
           voltage_meas();
          display.clearDisplay();
          robojaxText("Bat", 4, 0, 2, false);
          robojaxText("#", 10, 18, 2, false);
          String bat_numb = String(bat);          
          robojaxText(bat_numb, 24, 18, 2, false);
          String Volt = String(vbat, 2);
          robojaxText(Volt, 43, 5, 3, false);
          robojaxText("V", 113, 13, 2, false);
          display.drawRect(42, 0, 86,32, WHITE);
          display.display(); 
 delay(100);         
} 
  
 void voltage_meas() {
  acc_value = 0; 
  for (int i=0; i <= 15; i++){
  curr_value = analogRead(sensorPin);   
  acc_value = acc_value + curr_value; 
  }      
  vbat_dig = int(acc_value/16);
  vbat = vbat_dig*supply/1024;  
}

void robojaxText(String text, int x, int y,int size, boolean d) {
  display.setTextSize(size);
  display.setTextColor(WHITE);
  display.setCursor(x,y);
  display.println(text);
  if(d){
    display.display();
  }  
}

